'Compilable Example:
#Compiler PBWin 9, PBWin 10
#Compile Exe  "gbfindfolder.exe"
#Dim All
%Unicode=1

#Include "Win32api.inc"

#Resource Icon logo "images\gbfindfolder.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xsearchall "images\searchall.ico"
#Resource Icon xsearchlist "images\searchlist.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xfont "images\font.ico"

Enum Equates Singular
   IDC_Toolbar    = 500
   IDC_SearchTerm
   IDC_StartFolder
   IDC_LabelH
   IDC_SearchTermL
   IDC_StartFolderL
   IDC_FolderListL
   IDC_MatchListL
   IDC_SearchTermHistory
   IDC_StartFolderHistory

   IDC_FolderList
   IDC_MatchList

   IDT_Folder
   IDT_SearchAll
   IDT_SearchWithin
   IDT_Settings
   IDT_Font
   IDT_Help

   IDM_Clear
   IDM_UseSelected
   IDM_UseC
   IDM_Sep
   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete
   IDM_Return
End Enum,

$Ver = "1.0"
$SessionFolders = "tempfiles\gbfindfolder_folders.txt"
$SessionMatch = "tempfiles\gbfindfolder_match.txt"

Global hDlg,hFont,hFontC,hImageList,hHook,hContext,hContextT As Dword, OldProc&
Global SplitHInWork, HBarLeft, OldProc As Long
Global Folders() As DirData, tempArray() As String
Global FolderCount,MatchCount As Long
Global StartFolder, SearchTerm, FontName, History() As WStringZ * %Max_Path
Global FontSize, FontStyle As Long
Global qstop, qstart, qFreq As Quad

Function PBMain()
   Dialog New Pixels, 0, "gbFindFolder   v" + $ver,300,300,410,340, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   Control Add Label, hDlg, %IDC_LabelH, "",  200, 220, 6, 125, %WS_Child Or %SS_Notify , %WS_Ex_ClientEdge  ' up/down - does horizontal split
   Control Set Color hDlg, %IDC_LabelH, %Black, %Blue

   Control Add Label, hDlg, %IDC_SearchTermL, "Search String",   5, 55, 100, 15
   Control Add Label, hDlg, %IDC_StartFolderL, "Start Folder", 110, 55, 100, 15
   Control Add TextBox, hDlg, %IDC_SearchTerm, "",5,75,100,20
   Control Add ListBox, hDlg, %IDC_SearchTermHistory, ,  5, 95, 100, 90, %LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge

   Control Add TextBox, hDlg, %IDC_StartFolder, "",110,75,400,20
   Control Add ListBox, hDlg, %IDC_StartFolderHistory, ,  110, 95, 160, 90, %LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge

   Control Add Label, hDlg, %IDC_FolderListL, "All Folders",  5, 190, 150, 15
   Control Add Label, hDlg, %IDC_MatchListL, "Matching Folders",  170, 190, 150, 15
   Control Add ListBox, hDlg, %IDC_FolderList, ,  5, 210, 160, 80, %LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge
   Control Add ListBox, hDlg, %IDC_MatchList, , 170, 210, 160, 80, %LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge

   Dialog Show Modal hDlg Call DlgProc()
End Function

CallBack Function DlgProc() As Long
   Local i,x,y,w,h As Long, PTT As TooltipText Ptr, temp$, pt As Point
   Select Case Cb.Msg
      Case %WM_InitDialog
         ReDim History(9)
         QueryPerformanceFrequency qFreq
         BuildAcceleratorTable
         OldProc& = SetWindowLong(GetDlgItem(hDlg, %IDC_SearchTerm), %GWL_WndProc, CodePtr(NewTextProc))  'subclass
         OldProc& = SetWindowLong(GetDlgItem(hDlg, %IDC_StartFolder), %GWL_WndProc, CodePtr(NewTextProc))  'subclass
         Settings_ini "get"
         'Fonts
         Font New "Tahoma", 10, 0 To hFontC
         For i = %IDC_Toolbar To %IDC_StartFolderHistory
            Control Set Font hDlg, i, hFontC
         Next i
         'Context Menu
         CreateContextMenus
         'Initialize Control Content
         Control Set Text hDlg, %IDC_SearchTerm, SearchTerm
         Control Set Text hDlg, %IDC_StartFolder, StartFolder
         SetControlFonts
         CreateSubFolders
         LoadSession
         For i = 4 To 0 Step - 1 : ListBox Insert hDlg, %IDC_SearchTermHistory, 1, History(i)  : Next i
         For i = 9 To 5 Step - 1 : ListBox Insert hDlg, %IDC_StartFolderHistory, 1, History(i) : Next i
         Dialog Get Client hDlg To w,h
         If HBarLeft = 0 Then HBarLeft = 150
         Control Set Loc hDlg, %IDC_LabelH, HBarLeft, 210
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Clear
               ListBox Reset hDlg, %IDC_FolderList
               ListBox Reset hDlg, %IDC_MatchList

            Case %IDM_UseSelected
               Select Case GetFocus
                  Case GetDlgItem(hDlg, %IDC_FolderList)
                     ListBox Get Select hDlg, %IDC_FolderList To i
                     ListBox Get Text hDlg, %IDC_FolderList, i To temp$
                     Control Set Text hDlg, %IDC_StartFolder, temp
                  Case GetDlgItem(hDlg, %IDC_MatchList)
                     ListBox Get Select hDlg, %IDC_MatchList To i
                     ListBox Get Text hDlg, %IDC_MatchList, i To temp$
                     Control Set Text hDlg, %IDC_StartFolder, temp
               End Select

            Case %IDM_UseC
               Control Set Text hDlg, %IDC_StartFolder, "c:\"

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDM_Return
               Select Case GetFocus
                  Case GetDlgItem(hDlg, %IDC_FolderList)
                     ListBox Get Select hDlg, %IDC_FolderList To i
                     ListBox Get Text hDlg, %IDC_FolderList, i To temp$
                     i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  Case GetDlgItem(hDlg, %IDC_MatchList)
                     ListBox Get Select hDlg, %IDC_MatchList To i
                     ListBox Get Text hDlg, %IDC_MatchList, i To temp$
                     i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  Case GetDlgItem(hDlg, %IDC_SearchTerm)  : SearchForFolders(1)
                  Case GetDlgItem(hDlg, %IDC_StartFolder) : SearchForFolders(1)
               End Select

            Case %IDC_SearchTermHistory
               If Cb.CtlMsg = %LBN_DblClk Then
                  ListBox Get Select hDlg, %IDC_SearchTermHistory To i
                  ListBox Get Text hDlg, %IDC_SearchTermHistory, i To temp$
                  Control Set Text hDlg, %IDC_SearchTerm, temp$
               End If

            Case %IDC_StartFolderHistory
               If Cb.CtlMsg = %LBN_DblClk Then
                  ListBox Get Select hDlg, %IDC_StartFolderHistory To i
                  ListBox Get Text hDlg, %IDC_StartFolderHistory, i To temp$
                  Control Set Text hDlg, %IDC_StartFolder, temp$
               End If

            Case %IDC_FolderList
               If Cb.CtlMsg = %LBN_DblClk Then
                  ListBox Get Select hDlg, %IDC_FolderList To i
                  ListBox Get Text hDlg, %IDC_FolderList, i To temp$
                  i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
               End If

            Case %IDC_MatchList
               If Cb.CtlMsg = %LBN_DblClk Then
                  ListBox Get Select hDlg, %IDC_MatchList To i
                  ListBox Get Text hDlg, %IDC_MatchList, i To temp$
                  i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
               End If

            Case %IDT_Folder
               SelectFolder

            Case %IDT_Font
               SelectControlFont

            Case %IDT_Settings

            Case %IDT_Help
               i = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbfindfolder.htm", $Nul, $Nul, %SW_ShowNormal)
            Case %IDT_SearchAll
               SearchForFolders(1)
            Case %IDT_SearchWithin
               SearchForFolders(0)
         End Select

      Case %WM_ContextMenu
         pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)
         ScreenToClient hDlg, pt
         If (ChildWindowFromPoint(hDlg,pt) = GetDlgItem(hDlg, %IDC_FolderList)) Or (ChildWindowFromPoint(hDlg,pt) = GetDlgItem(hDlg, %IDC_MatchList)) Then
            x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
            TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, Cb.Hndl, ByVal 0
         End If

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_Folder To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_Folder       : @PTT.@lpszText = "Select Starting Folder"
                        Case %IDT_SearchAll    : @PTT.@lpszText = "Find All Folders and Matching Folders That Are Beneath the Starting Folder"
                        Case %IDT_SearchWithin : @PTT.@lpszText = "Find All Folders and Matching Folders That Are In The Displayed Folder List"
                        Case %IDT_Settings     : @PTT.@lpszText = "Settings"
                        Case %IDT_Help         : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select
         End Select

      Case %WM_Size
         ResizeWindow

      Case %WM_SetCursor
         i = GetDlgCtrlID (Cb.WParam)  'determine which over which label control mouse was moved
         If i = %IDC_LabelH Then MousePtr 9 : Function = 1    '9 = horizontal cursor
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               If i = %IDC_LabelH Then SplitHInWork = 1 : MoveBarLeftRight
            Case %WM_MouseMove
               If SplitHInWork Then MoveBarLeftRight
            Case %WM_LButtonUp
               If SplitHInWork Then
                  SplitHInWork = 0  'sets flags to say splitter action has ended
                  MoveBarLeftRight
                  Control Set Color hDlg, %IDC_LabelH, %Black, %Blue
                  ResizeWindow
               End If
         End Select
      Case %WM_Destroy
         Control Get Text hDlg, %IDC_SearchTerm To SearchTerm
         Control Get Text hDlg, %IDC_StartFolder To StartFolder
         SaveSession
         Settings_ini "save"
   End Select
End Function

Sub MoveBarLeftRight
   Local pt As Point, w,h,BarColor As Long
   'get new HBarLeft position
   GetCursorPos pt               'pt has xy screen coordinates
   ScreenToClient hDlg, pt       'pt now has client coordinates
   HBarLeft = pt.x-3
   'splitterbar colors - change colors when move is in work
   Control Set Color hDlg, %IDC_LabelH, %Black, %Red
   'resize splitterbars
   Dialog Get Client hDlg To w,h
   Control Set Loc hDlg, %IDC_LabelH, HBarLeft, 210
End Sub


Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_LabelH, 6, h - 215

   Control Set Size hDlg, %IDC_StartFolder, w - 115, 20
   Control Set Size hDlg, %IDC_StartFolderHistory, w - 115, 90

   Control Set Size hDlg, %IDC_FolderList, HBarLeft - 10, h - 215

   Control Set Loc  hDlg, %IDC_MatchListL, HBarLeft + 10 , 190
   Control Set Loc  hDlg, %IDC_MatchList, HBarLeft + 10, 210
   Control Set Size hDlg, %IDC_MatchList, w - HBarLeft - 15, h - 215

   Dialog ReDraw hDlg
End Sub

Sub GetFolderList
   Local iPOS As Long, tempDIR As DirData, temp$
   Folders(FolderCount).FileName = StartFolder
   While Len(Folders(iPOS).FileName)
      temp$ = Dir$(Folders(iPOS).FileName + "\*.*", Only %SubDir To tempDir)  'subfolders only
      tempDir.FileName = StartFolder + "\" + tempDir.FileName
      While Len(temp$)
         Incr FolderCount
         If FolderCount > UBound(Folders) Then ReDim Preserve Folders(UBound(Folders) + 20000)
         Folders(FolderCount) =  tempDir
         Folders(FolderCount).FileName = Folders(iPos).FileName + "\" + temp$
         temp$ =  Dir$ (Next, To tempDir)
         tempDir.FileName = StartFolder + "\" + tempDir.FileName
         If FolderCount Mod 100 = 0 Then Sleep 0
      Wend
      Incr iPOS
   Wend
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "550", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "StartFolder", Exe.Path$, StartFolder, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchTerm", "picture", SearchTerm, %Max_Path, INIFileName
      For x = 0 To 9
         Getprivateprofilestring "All", "History" + Format$(x,"00"), "", History(x), %Max_Path, INIFileName
      Next i
      If History(0) = "" Then History(0) = "gbapps"
      If History(1) = "" Then History(1) = "data"
      If History(2) = "" Then History(2) = "movie"
      If History(3) = "" Then History(3) = "image"
      If History(4) = "" Then History(4) = "unused"

      If History(5) = "" Then History(5) = "c:\"
      If History(6) = "" Then History(6) = "c:\data"
      If History(7) = "" Then History(7) = "c:\data\gbapps"
      If History(8) = "" Then History(8) = "d:\"
      If History(9) = "" Then History(9) = "d:\data"

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontStyle", "0", temp, %Max_Path, INIFileName:  FontStyle = Val(temp)
      Getprivateprofilestring "All", "HBarLeft", "250", temp, %Max_Path, INIFileName:  HBarLeft = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "StartFolder",StartFolder, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      For x = 0 To 9
         WritePrivateProfileString "All", "History" + Format$(x,"00"),History(x), INIFileName
      Next x
      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontStyle", Str$(FontStyle), INIFileName
      WritePrivateProfileString "All", "HBarLeft", Str$(HBarLeft), INIFileName
   End If
End Sub

Sub CreateToolbar
   ImageList New Icon 24,24,24,10 To hImageList
   ImageList Add Icon hImageList, "xopen"       '1
   ImageList Add Icon hImageList, "xsearchall"  '2
   ImageList Add Icon hImageList, "xsettings"   '3
   ImageList Add Icon hImageList, "xhelp"       '4
   ImageList Add Icon hImageList, "xfont"       '5
   ImageList Add Icon hImageList, "xsearchlist" '6
   Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat
   Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0
   Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_Folder, %BTNS_Button, "Folder"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_SearchAll,  %BTNS_Button, "New Search"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_SearchWithin,  %BTNS_Button, "Search Within"
   Toolbar Add Separator hDlg, %IDC_Toolbar, 20
   Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Font,  %BTNS_Button, "Font"
'   Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Settings,  %BTNS_Button, "Settings"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Help,  %BTNS_Button, "Help"
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
   If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
End Sub

Sub SetControlFonts
   Font New FontName, FontSize, FontStyle To hFont
   Control Set Font hDlg, %IDC_FolderList, hFont
   Control Set Font hDlg, %IDC_MatchList, hFont
End Sub

Sub LoadSession
   Local iCount, i As Long, temp$
   'SessionFolders
   If IsFile($SessionFolders) Then
      Open $SessionFolders For Input As #1
      While IsFalse(Eof(1))
         Line Input #1, temp$
         If Len(temp$) Then ListBox Add hDlg, %IDC_FolderList, temp$
      Wend
      Close #1
   End If
   'SessionMatch
   If IsFile($SessionMatch) Then
      Open $SessionMatch For Input As #1
      While IsFalse(Eof(1))
         Line Input #1, temp$
         If Len(temp$) Then ListBox Add hDlg, %IDC_MatchList, temp$
      Wend
      Close #1
   End If
End Sub

Sub SaveSession
   Local iCount, i As Long, temp$
   'SessionFolders
   ListBox Get Count hDlg, %IDC_FolderList To iCount
   Open $SessionFolders For Output As #1
   For i = 1 To iCount
      ListBox Get Text hDlg, %IDC_FolderList, i To temp$
      Print #1, temp$
   Next i
   Close #1

   'SessionMatch
   ListBox Get Count hDlg, %IDC_MatchList To iCount
   Open $SessionMatch For Output As #1
   For i = 1 To iCount
      ListBox Get Text hDlg, %IDC_MatchList, i To temp$
      Print #1, temp$
   Next i
   Close #1

End Sub

Sub SelectFolder
   Local title$, start$, flags&, folder$
   title$ = "Select Folder"    'if "" then "Open" is used
   start$ = IIf$(IsFolder(StartFolder),StartFolder,Exe.Path$)
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$
   If Len(folder$) Then
      StartFolder = Trim$(folder$,"\")
      Control Set Text hDlg, %IDC_StartFolder, StartFolder
   End If
End Sub

Sub SelectControlFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontStyle, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx hHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontStyle = fStyle
      SetControlFonts
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal hHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx hHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function NewTextProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextT, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateContextMenus
   'ListBoxes
   Menu New PopUp To hContext
   Menu Add String, hContext, "Clear Both Sides", %IDM_Clear, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Use Selected Folder As Start Folder", %IDM_UseSelected, %MF_Enabled
   Menu Add String, hContext, "Use c:\ As Start Folder", %IDM_UseC, %MF_Enabled
   'TextBoxes
   Menu New PopUp To hContextT
   Menu Add String, hContextT, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContextT, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContextT, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContextT, "Delete", %IDM_Delete,  %MF_Enabled
End Sub


Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(6)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1     : ac(cc).cmd  = %IDT_Help      : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F3     : ac(cc).cmd  = %IDT_SearchAll : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_F      : ac(cc).cmd  = %IDT_Folder    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_H      : ac(cc).cmd  = %IDT_Help      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N      : ac(cc).cmd  = %IDM_Clear     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S      : ac(cc).cmd  = %IDT_SearchAll : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_Return : ac(cc).cmd  = %IDM_Return    : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub SearchForFolders(NewSearch As Long)
   Local i As Long
   'get search parameters
   Control Get Text hDlg, %IDC_StartFolder To StartFolder
   StartFolder = Trim$(LCase$(StartFolder),"\")
   Control Get Text hDlg, %IDC_SearchTerm To SearchTerm
   SearchTerm = LCase$(SearchTerm)
   UpdateHistoryList

   MousePtr 11
   'do this for new Search only
   If NewSearch Then
      FolderCount = 0
      ReDim Folders(100000)
      'Search for list of folders, from StartFolder down, including all subfolders
      QueryPerformanceCounter qStart
      GetFolderList
      QueryPerformanceCounter qStop
      'Fill FolderList
      ListBox Reset hDlg, %IDC_FolderList
      For i = 0 To FolderCount
         ListBox Add hDlg, %IDC_FolderList, Folders(i).FileName
      Next i
      Dialog Set Text hDlg, "gbFindFolder   v" + $ver  +  "     Search Time: " + Format$((qStop-qStart)/qFreq,"  0.###") + "s"
   Else
      Dialog Set Text hDlg, "gbFindFolder   v" + $ver
   End If

   'Fill MatchList
   ListBox Reset hDlg, %IDC_MatchList
   MatchCount = 0
   For i = 0 To FolderCount
      If InStr( LCase$(Folders(i).FileName), SearchTerm) Then
         ListBox Add hDlg, %IDC_MatchList, Folders(i).FileName
         Incr MatchCount
      End If
   Next i
   MousePtr 1

   Control Set Text hDlg, %IDC_FolderListL, "All Folders   (" + Trim$(Str$(FolderCount)) + ")"
   Control Set Text hDlg, %IDC_MatchListL, "Matching Folders   (" + Trim$(Str$(MatchCount)) + ")"
End Sub

Sub UpdateHistoryList
   Local i As Long, temp$
   'Search Term History
   Array Scan History(0) For 5, Collate UCase,  = SearchTerm, To i
   If i Then
      'already in list - take no action
   Else
      'new search term
      Array Delete History(4)
      Array Insert History(0), SearchTerm
   End If

   'Start Folder History
   Array Scan History(5) For 5, Collate UCase, = StartFolder, To i
   If i Then
      'already in list - take no action
   Else
      'new search term
      Array Delete History(9)
      Array Insert History(5), StartFolder
   End If

   'Display New History Lists
   ListBox Reset hDlg, %IDC_SearchTermHistory
   ListBox Reset hDlg, %IDC_StartFolderHistory
   For i = 4 To 0 Step -1 : ListBox Insert hDlg, %IDC_SearchTermHistory, 1, History(i)  : Next i
   For i = 9 To 5 Step -1 : ListBox Insert hDlg, %IDC_StartFolderHistory, 1, History(i) : Next i
End Sub
